#include "mbed.h"

#define PC_BAUDRATE     115200
#define DEV_BAUDRATE    115200

UnbufferedSerial  pc(USBTX, USBRX);

#if defined(TARGET_NUMAKER_IOT_M487)
UnbufferedSerial  dev(PH_8, PH_9);
DigitalOut dev_rst(PH_3, 1);

#elif defined(TARGET_NUMAKER_IOT_M467)
UnbufferedSerial  dev(PC_1, PC_0);
DigitalOut dev_rst(PC_4, 1);

#elif defined(TARGET_NUMAKER_IOT_M263A) || defined(TARGET_NU_M2354)
UnbufferedSerial  dev(PC_7, PC_6);
DigitalOut dev_rst(PE_12, 1);

#else
#error No proper board selected

#endif

DigitalOut led1(LED1);
DigitalOut led2(LED2);

void dev_recv()
{
    char c;

    led1 = !led1;
    while(dev.readable()) {
        dev.read(&c, 1);
        pc.write(&c, 1);
    }
}

void pc_recv()
{
    char c;

    led2 = !led2;
    while(pc.readable()) {
        pc.read(&c, 1);
        dev.write(&c, 1);
    }
}

int main()
{
    pc.baud(PC_BAUDRATE);
    dev.baud(DEV_BAUDRATE);

    printf("Starting pass-through firmware...\r\n");
    pc.attach(&pc_recv, SerialBase::RxIrq);
    dev.attach(&dev_recv, SerialBase::RxIrq);

    while(1)
        sleep();
}
